#include <aes.h>
#include <tos.h>
#include <vdi.h>
#include <portab.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "eco_sys.h"			/* Valeur des champs du ressource */

extern int _app;

typedef enum
{
    FALSE,
    TRUE
}
boolean;

#define TRINDEX 			  0
#define FRSTR 				  0
#define NB_TREE 			  0
#define ME_HIDE               0
#define ME_SHOW               1
#define ME_NORM               1
#define DESK                  0
#define RSC_NAME              "ECO_SYS.RSC"

OBJECT *D_tree;
OBJECT *Ic_bureau;
int	objet, handle;
int x_objet, y_objet;
int app_id, menu_id, ancien_nb_ligne;
int prog = 0;
char ancien_gem[51][129], gem[21][129], p_id[5], P_id[21][5];
char ancien_sh_rpcmd[129], ancien_p_id[5]=".000", version[14]="Version: 1.00";
int work_in[11]= {0,1,1,1,1,1,1,1,1,1,2}, work_out[57];
int dum, handle;
long	*cookies;
boolean  Mint = FALSE;

void main( void );
void event_loop( void );
void mouse_on( void );
void mouse_off( void );
int affiche_arbre( OBJECT *arbre );
int affiche_arbre2( OBJECT *arbre, int x, int y );
void lire_event( void );
void mise_a_jour( void );
void sauve_gem_cnf(void);
void open_work (void);
int  handle_message( int pipe[8] );
int lit_ancien_gem( void );
long get_cookiejar(void);
	
/* -------------------------------------------------------------------- */

void main( void )
{
	int max_init;
	char sh_rpcmd[129], sh_rptail[129];
	long cookie;
		
	if ((cookie = Supexec(get_cookiejar)) == 0L)
	{
		Mint = FALSE;
	}
	else
	{
		Mint = TRUE;
	}

   app_id = appl_init( );
   if ( app_id != -1 )
   {

        if ( !_app )				 /*  Accessory   */
		{
	       graf_mouse( BUSYBEE, 0 );
			open_work ();
			
			if  ( rsrc_load( RSC_NAME ) > 0 )
			{
            	menu_id = menu_register( app_id, "  Eco-system " );
				rsrc_gaddr( 0, DIALOG_1, &D_tree );
				rsrc_gaddr( 0, ICONE_BUREAU, &Ic_bureau );
				
				/* a 'est pour une chaine */
				/* strcpy(D_tree[obj].ob_spec.free_string, version);*/

				/* a 'est pour un texte */
				strcpy(D_tree[VERSION].ob_spec.tedinfo->te_ptext, version);


/* Proposition d'affichage d' icone durant le chargement de l'accessoire 
 Si app_id >= 4  parce qu'en dessous de 4 sous Mint il y a deja:
	application		app_id
	Mint			000
	Aes				001
	Screen			002
	Newdesk			003
	Xcontrol		004
	
*/				    if ( app_id >= 4 )
      				{

/* max_init est le nombre maximum d'icone que l'on peut afficher sur
	une ligne. Largeur maximum de l'icone est placer a 75 points et
	la hauteur  49 points. */
	
    					max_init = work_out[0]/75;

/* Si mon identificateur est suprieur a max_init on decremente d'une ligne*/

						if ( app_id > max_init )
						{

							y_objet = ( app_id /max_init )+1;
							x_objet = app_id - ( y_objet-1 ) * max_init;
		    				y_objet = work_out[1]-( 49 * y_objet );
      						x_objet = x_objet * 75;
						}
      					else
      					{
      						x_objet = ( ( app_id - 4 ) *75 );
		    				y_objet = work_out[1]-49;
      					}
    				}
    				else
    				{
      					x_objet = ( app_id * 75 );
		    			y_objet = work_out[1]-49;
    				}
/* Ici on lit dans la mmoire d'evenement */
				shel_read( sh_rpcmd, sh_rptail);
				
/* Si mon accessoire n'est pas lancer  partir du bureau sous mint
  alors on affiche l'icone init.*/
				if ( strstr( sh_rpcmd, "ECO_SYS.ACC" ) == NULL || !Mint )
				{
					affiche_arbre2( Ic_bureau, x_objet, y_objet );
				}
				
				lit_ancien_gem();
				graf_mouse( ARROW, 0 );
				event_loop( );

			}
      
      	}
      appl_exit( );
    }
   exit( 0 );
}

/* -------------------------------------------------------------------- */

void mouse_on( void )

{
   graf_mouse( M_ON, (void *)0 );
}

/* -------------------------------------------------------------------- */

void mouse_off( void )
{
   graf_mouse( M_OFF, (void *)0 );
}

/* -------------------------------------------------------------------- */

int handle_message( int pipe[8] )
{
   switch ( pipe[0] )
   {
      case AC_OPEN:
         if ( pipe[4] == menu_id )
		 {
			if ( Mint )
			{
				if( affiche_arbre(D_tree) == SAUVER )
					sauve_gem_cnf();
		 	}
		 	else
		 	{
	 			form_alert (1, "[1][Seulement avec Multitos !| |][ Ok ]");
		 	}
		 }
      break;

   }
   return ( 0 );
}

/* -------------------------------------------------------------------- */

void event_loop( void )
{
   int x, y,
       kstate,
       key,
       clicks,
       event,
       state;
   int pipe[8];
   int quit;

   quit = 0;
   
   do
   {
      event = evnt_multi( MU_MESAG | MU_TIMER,
                          2, 0x1, 1,
                          0, 0, 0, 0, 0,
                          0, 0, 0, 0, 0,
                          pipe,
                          1000, 0,
                          &x, &y, &state, &kstate, &key, &clicks );

      wind_update( BEG_UPDATE );

      if ( event & MU_MESAG )
         quit = handle_message( pipe );

      if ( event & MU_TIMER )
	  {
		if ( Mint )
			lire_event();
	  }	
      wind_update( END_UPDATE );
   }
   while ( !quit );
}

/* -------------------------------------------------------------------- */

int affiche_arbre( arbre )
OBJECT *arbre;
{

   int bouton;
   GRECT rect;
   GRECT xrect;
   
  	wind_update( BEG_UPDATE );
	wind_update(BEG_MCTRL);

   xrect.g_x = xrect.g_y = 10;
   xrect.g_w = xrect.g_h = 36;

   form_center( arbre, &rect.g_x, &rect.g_y, &rect.g_w, &rect.g_h );
   form_dial( FMD_START, xrect.g_x, xrect.g_y, xrect.g_w, xrect.g_h,
                         rect.g_x, rect.g_y, rect.g_w, rect.g_h );
   form_dial( FMD_GROW, xrect.g_x, xrect.g_y, xrect.g_w, xrect.g_h,
                         rect.g_x, rect.g_y, rect.g_w, rect.g_h );

   objc_draw( arbre, ROOT, MAX_DEPTH, rect.g_x, rect.g_y, rect.g_w,rect.g_h );

	bouton = form_do (arbre, ROOT);

   
   form_dial( FMD_SHRINK, xrect.g_x, xrect.g_y, xrect.g_w, xrect.g_h,
                         rect.g_x, rect.g_y, rect.g_w, rect.g_h );

   form_dial( FMD_FINISH, xrect.g_x, xrect.g_y, xrect.g_w, xrect.g_h,
                         rect.g_x, rect.g_y, rect.g_w, rect.g_h );
    arbre[ bouton ].ob_state &= ~SELECTED;

	wind_update(END_MCTRL);
   	wind_update( END_UPDATE );

    return (bouton);
}

/* -------------------------------------------------------------------- */

int affiche_arbre2( arbre, x, y )
OBJECT *arbre;
{
	if ( Mint )
    {
    	arbre[ ICO_BUREAU ].ob_state &= ~SELECTED;
	}

	arbre->ob_x = x;
	arbre->ob_y = y;

   objc_draw( arbre, ICO_BUREAU, MAX_DEPTH, x, y, 72, 40 );
	
return(0);
}

/* -------------------------------------------------------------------- */

void lire_event( void )
{
char sh_rpcmd[129], sh_rptail[129];
char *debut, *fin, nom[13], process_id[5];
int c = '\\', pid, point = '.', i;

	shel_read( sh_rpcmd, sh_rptail);
	

	if (strrchr( sh_rpcmd, c ))
	{
		debut = strrchr( sh_rpcmd, c )+1;

		strcpy( nom, debut );
		fin = strrchr( nom, point );
		*fin = '\0';
		if ( strlen( nom ) <  8 )
		{
			for ( i= (int) strlen( nom ); i<=8; i++)
				 strcat( nom, " ");
		}
		pid = appl_find( nom );
		if ( pid <= 0)
		{
			pid = 100;
		}
		itoa( pid, process_id,10);
		if ( strlen( process_id )==1)
		{
			strcpy( p_id, ".00");
			strcat( p_id, process_id);
		}
		else if ( strlen( process_id )==2)
		{
			strcpy( p_id, ".0");
			strcat( p_id, process_id);
		}
		else
		{
			strcpy( p_id, ".");
			strcat( p_id, process_id);
		}

		strcpy( nom, debut );
	
		if ( strlen( sh_rpcmd ) )
		{
			if ( strstr( sh_rpcmd, "MINIWIN.APP" ) || strstr( sh_rpcmd, "VIEWER.APP" ) || strstr( sh_rpcmd, "LPR.APP" ))
			{
					strcpy( sh_rpcmd, "rien" );
			}	

/*			if ( strcmp( ancien_sh_rpcmd, sh_rpcmd) != 0 || strcmp( ancien_p_id, p_id) != 0 ) 	*/

			if ( strcmp( ancien_p_id, p_id) != 0 )
			{


				if ( strstr( nom, ".APP" ) || strstr( nom, ".PRG" ))
				{
					if( prog == 20 )
					{
						mise_a_jour();
					}

		
				++( prog );
				strcpy( gem[prog], sh_rpcmd);
				strcpy( P_id[prog], p_id);
        		strcpy( ancien_sh_rpcmd, sh_rpcmd);
        		strcpy( ancien_p_id, p_id);
				
				}
			}
		}
	}
}

/* -------------------------------------------------------------------- */

void mise_a_jour( void )
{
int i, cmp=0;
char fichier[129], *debut, *fin, nom[13];
int c = '\\', point = '.';

	for ( i = 1; i <= 20; i++ )
	{
		if (strlen( gem[i] ) && strcmp( gem[i], "rien" ) != 0 )
		{
			
			strcpy( fichier, "U:\\PROC\\" );
			debut = strrchr( gem[i], c )+1;
			if ( strlen( debut ) )
			{
				strcpy( nom, debut );
				fin = strrchr( nom, point );
				*fin = '\0';
				strcat( fichier, nom );
				strcat( fichier, P_id[i] );

				if (Fsfirst (fichier, 0) == 0)		/* S'il existe */
				{
					++(cmp);
					strcpy( gem[cmp], gem[i]);
				}
			}	
		}
	}
	prog = cmp;
}

/* -------------------------------------------------------------------- */

int lit_ancien_gem( void )
{
	FILE *fp;
	int i = 0;
	char buff[129];
	long var;


	if ((fp = fopen( "c:\\gem.cnf", "r")) == NULL )
	{
		i = 0;
	}
	else
	{
		while(!feof( fp ) && i < 50 )
		{
			var = fgets( buff, 128, fp);

			if( strlen( buff ) > 2  && buff[0] != '#' && buff[0] != 'r' && var != NULL )
			{
				++(i);
				strcpy( ancien_gem[i], buff );
			}
		}
		fclose( fp );
	}

	ancien_nb_ligne = i;

	return ( ancien_nb_ligne );		
}

/* -------------------------------------------------------------------- */

void sauve_gem_cnf(void)
{
	int i;
	FILE *fp;
	
	mise_a_jour();

	graf_mouse( BUSYBEE, 0 );


	if ((fp = fopen( "c:\\gem.cnf", "w")) > 0 )
	{
		fprintf(fp,"#================================================================\n");
		fprintf(fp,"# GEM.CNF ==> Configuration de Mint.\n");
		fprintf(fp,"# Cr par ECO_SYS.ACC\n");
		fprintf(fp,"# 1993 Rodolfo Thierry (France)\n");
		fprintf(fp,"#================================================================\n");

			for( i = 1; i <= ancien_nb_ligne; i++ )
			{
				fprintf(fp,"%s",ancien_gem[i]);
			}

			for( i = 1; i <= prog; i++ )
			{
			fprintf(fp,"run %s\n", gem[i] );
			}
	}
	fclose( fp );
	graf_mouse( ARROW, 0 );
}

/* -------------------------------------------------------------------- */

void open_work (void)
{
	handle = graf_handle(&dum,&dum,&dum,&dum);
	work_in[0] = Getrez()+2;
	v_opnvwk(work_in, &handle, work_out);
}

/* -------------------------------------------------------------------- */

long get_cookiejar(void)
{
	long	**_cookiejar = (long **)0x5A0;
	int		  used;
	
	if (*_cookiejar == NULL)
	  return(0L);

	cookies = *_cookiejar;
	for (used = 0; cookies[2*used] != 0L; used++)
		if (cookies[2*used] == 0x4d694e54L)
			break;
	if (cookies[2*used] == 0L)
		return(0L);
	return(1L);
}

/* -------------------------------------------------------------------- */
